﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinCalcManager;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication15
{
    public partial class Form1 : Form
    {
        private string theText;
        private string holdKey = "";
        private int holdLoc = -1;
        private System.Data.DataSet _dataSet;
        private Infragistics.Win.UltraWinCalcManager.UltraCalcManager calc1;

        public Form1()
        {
            InitializeComponent();

            calc1 = new UltraCalcManager();
            ultraGrid1.CalcManager = calc1;

            ultraGrid1.DisplayLayout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ExtendLastColumn;
            ultraGrid1.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy;
            ultraGrid1.DisplayLayout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            ultraGrid1.DisplayLayout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            ultraGrid1.DisplayLayout.Override.FilterEvaluationTrigger = Infragistics.Win.UltraWinGrid.FilterEvaluationTrigger.OnEnterKeyOrLeaveRow;
            ultraGrid1.DisplayLayout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.GroupByRowsFooter | Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.BottomFixed;
            ultraGrid1.DisplayLayout.Override.AllowRowSummaries = Infragistics.Win.UltraWinGrid.AllowRowSummaries.True;
            ultraGrid1.DisplayLayout.Override.FormulaRowIndexSource = Infragistics.Win.UltraWinGrid.FormulaRowIndexSource.Default;

            button2.Enabled = false;

            comboBox1.SelectedIndex = 0;
            
            _dataSet = new DataSet();
            _dataSet.Tables.Add("DataTable");
            ultraGrid1.SetDataBinding(_dataSet, "DataTable");

            _dataSet.Tables[0].Columns.Add("First Name");
            _dataSet.Tables[0].Columns.Add("Last Name");
            _dataSet.Tables[0].Columns.Add("Sales", typeof(double));
            _dataSet.Tables[0].Columns.Add("Cost", typeof(double));

            _dataSet.Tables[0].Rows.Add(new object[] { "Chris", "Smith", 50.0, 40.0 });
            _dataSet.Tables[0].Rows.Add(new object[] { "Chris", "Smith", 32.5, 15.0 });
            _dataSet.Tables[0].Rows.Add(new object[] { "Chris", "Smith", 16.6, 4.5 });
            _dataSet.Tables[0].Rows.Add(new object[] { "Chris", "Smith" , 18.5, 10.2});
            _dataSet.Tables[0].Rows.Add(new object[] { "Chris", "Smith" , 99.99, 45.55});
            _dataSet.Tables[0].Rows.Add(new object[] { "Dave", "Smith" , 22.00, 10.00});
            _dataSet.Tables[0].Rows.Add(new object[] { "Dave", "Smith" , 28.00, 19.95});
            _dataSet.Tables[0].Rows.Add(new object[] { "Mark", "Smith" , 36.33, 20.70});
            _dataSet.Tables[0].Rows.Add(new object[] { "Mark", "Smith" , 45.22, 23.00});
            _dataSet.Tables[0].Rows.Add(new object[] { "Mark", "Smith" , 38.38, 17.00});

            
            ultraGrid1.DisplayLayout.PerformAutoResizeColumns(true, Infragistics.Win.UltraWinGrid.PerformAutoSizeType.AllRowsInBand, true);


            ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, ultraGrid1.DisplayLayout.Bands[0].Columns["Sales"]);
            ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, ultraGrid1.DisplayLayout.Bands[0].Columns["Cost"]);
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Infragistics.Win.UltraWinGrid.UltraGridColumn insertColumn = ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Test");
            ultraGrid1.DisplayLayout.Bands[0].Columns[insertColumn.Key].Formula = "[Sales] - [Cost]";
            calc1.ReCalc();

            button2.Enabled = true;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.SelectedIndex == 0)
            {
                ultraGrid1.DisplayLayout.Override.FormulaRowIndexSource = Infragistics.Win.UltraWinGrid.FormulaRowIndexSource.Default;
            }
            else
            {
                ultraGrid1.DisplayLayout.Override.FormulaRowIndexSource = Infragistics.Win.UltraWinGrid.FormulaRowIndexSource.ListIndex;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string formulaString = "(sum( [Sales] ) / sum( [Cost])) * 100";
            UltraGridColumn testColumn = ultraGrid1.DisplayLayout.Bands[0].Columns["Test"];
            
            ultraGrid1.DisplayLayout.Bands[0].Summaries.Add("% Total Test", formulaString, SummaryPosition.UseSummaryPositionColumn, testColumn);
            ultraGrid1.DisplayLayout.Bands[0].Summaries["% Total Test"].SummaryType = SummaryType.Formula;
            ultraGrid1.DisplayLayout.Bands[0].Summaries["% Total Test"].SourceColumn = testColumn;
            ultraGrid1.DisplayLayout.Bands[0].Summaries["% Total Test"].ToolTipText = "% Total = " + ultraGrid1.DisplayLayout.Bands[0].Summaries["% Total Test"].Formula;
            //Recalculate();
            
        }
    }
}
